package com.admin.system.domain

import com.fasterxml.jackson.annotation.JsonIgnore
import com.admin.security.domain.BaseModel
import com.admin.system.service.dto.DeptSmallDTO
import com.admin.system.service.dto.SysUserDTO
import org.springframework.beans.BeanUtils
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.ManyToMany
import javax.persistence.Table
import javax.validation.constraints.NotBlank
import javax.validation.constraints.NotNull

@Entity
@Table(name = "sys_dept")
open class SysDept : BaseModel() {
    /**
     * 名称
     */
    @Column(name = "name", nullable = false)
    @NotBlank
    var name: String? = null

    @NotNull
    var enabled: Boolean? = null

    /**
     * 上级部门
     */
    @Column(name = "pid", nullable = false)
    @NotNull
    var pid: Long? = null

    @JsonIgnore
    @ManyToMany(mappedBy = "depts")
    var roles: List<SysRole>? = null

    fun convertDto(): DeptSmallDTO {
        val dto = DeptSmallDTO()
        BeanUtils.copyProperties(this, dto)
        return dto
    }
}