package com.admin.system.domain

import com.admin.security.domain.BaseModel
import javax.persistence.*
import javax.validation.constraints.NotBlank

@Entity
@Table(name = "sys_dict")
open class SysDict : BaseModel() {


    /**
     * 字典名称
     */
    @Column(name = "name", nullable = false, unique = true)
    @NotBlank
    var name: String? = null

    /**
     * 描述
     */
    @Column(name = "remark")
    var remark: String? = null

    @OneToMany(mappedBy = "dict", cascade = [CascadeType.PERSIST, CascadeType.REMOVE])
    var dictDetails: List<SysDictDetail>? = null

}