package com.admin.system.domain

import com.admin.security.domain.BaseModel
import com.admin.system.service.dto.JobSmallDTO
import com.admin.system.service.dto.RoleSmallDTO
import org.springframework.beans.BeanUtils
import javax.persistence.*
import javax.validation.constraints.NotBlank
import javax.validation.constraints.NotNull

@Entity
@Table(name = "sys_job")
class SysJob : BaseModel() {

    /**
     * 名称
     */
    @Column(name = "name", nullable = false)
    @NotBlank
    var name: String? = null

    @Column(unique = true)
    @NotNull
    var sort: Long? = null

    /**
     * 状态
     */
    @Column(name = "enabled", nullable = false)
    @NotNull
    var enabled: Boolean? = null

    @OneToOne
    @JoinColumn(name = "dept_id")
    var dept: SysDept? = null

    fun convertDto(): JobSmallDTO {
        val dto = JobSmallDTO()
        BeanUtils.copyProperties(this, dto)
        return dto
    }
}