package com.admin.system.domain

import com.fasterxml.jackson.annotation.JsonIgnore
import com.admin.security.domain.BaseModel
import java.util.*
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.ManyToMany
import javax.persistence.Table
import javax.validation.constraints.NotBlank
import javax.validation.constraints.NotNull

@Entity
@Table(name = "sys_menu")
open class SysMenu : BaseModel() {


    @NotBlank
    private val name: String? = null

    @Column(unique = true)
    @NotNull
    private val sort: Long? = null

    @Column(name = "path")
    private val path: String? = null

    private val component: String? = null

    private val icon: String? = null

    /**
     * 上级菜单ID
     */
    @Column(name = "pid", nullable = false)
    private val pid: Long? = null

    /**
     * 是否为外链 true/false
     */
    @Column(name = "i_frame")
    private val iFrame: Boolean? = null

    @ManyToMany(mappedBy = "menus")
    @JsonIgnore
    private val roles: List<SysRole>? = null


    override fun equals(o: Any?): Boolean {
        if (this === o) return true
        if (o == null || javaClass != o.javaClass) return false
        val menu = o as SysMenu?
        return id == menu!!.id
    }

    override fun hashCode(): Int {
        return Objects.hash(id)
    }
}
