package com.admin.system.domain

import com.fasterxml.jackson.annotation.JsonIgnore
import com.admin.security.domain.BaseModel
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.ManyToMany
import javax.persistence.Table
import javax.validation.constraints.NotBlank
import javax.validation.constraints.NotNull

@Entity
@Table(name = "sys_permission")
class SysPermission : BaseModel() {


    @NotBlank
    val name: String? = null

    /**
     * 上级类目
     */
    @NotNull
    @Column(name = "pid", nullable = false)
    val pid: Long? = null

    @NotBlank
    val alias: String? = null

    @JsonIgnore
    @ManyToMany(mappedBy = "permissions")
    val roles: Set<SysRole>? = null

    override fun toString(): String {
        return "Permission{" +
                "id=" + id +
                ", name='" + name + '\''.toString() +
                ", pid=" + pid +
                ", alias='" + alias + '\''.toString() +
                '}'.toString()
    }
}
